#include <stdio.h>
#include <alloc.h>
#include <dos.h>
#include <io.h>

#define	PlainText	1
#define	TeXinclude	2
#define	MaxMode		2

#include "English.inc"
//#include "German.inc"
//#include "Czech.inc"
//#include "Spanish.inc"

// structure of PDB header
typedef struct {
  char name[32];
  unsigned int attr;
  unsigned int ver;
  unsigned long cdate;
  unsigned long mdate;
  unsigned long lbdate;
  unsigned long modnum;
  char appID[4];
  char sortID[4];
  char type[4];
  char creator[4];
  unsigned long IDseed;
} PDB_header;

// structure of records list header
typedef struct {
  unsigned long ID;
  unsigned int number;
} List_header;

// structure of record pointer
typedef struct {
  unsigned long offs;
  union {
    unsigned long ID;
    char attr;
  } u;
} List_record;

// structure of Fotopad data
typedef struct {
  unsigned long DateTime;
  char objektiv[16];
  unsigned int ohnisko;
  unsigned int clona;
  int cas;
  int korekce;
  char flags;
  char filtr[16];
  char popis[4001];
} RecordType;

// my DateTime structure
typedef struct {
  char day;
  char mon;
  unsigned int year;
  char hour, min, sec;
} DateType;

// Motorola uses swapped bytes (MSB first)
// SwitchBytes
void SB (void *ptr, int len) {
char c;
int i;
  i=len/2;
  while (i) {
    c=((char *)ptr)[i-1];
    ((char *)ptr)[i-1]=((char *)ptr)[len-i];
    ((char *)ptr)[len-i]=c;
    i--;
  }
}

// Long Filename support for Win9x
int lfn_open(char *name,char mode) {
  struct REGPACK r;

  r.r_ax=0x716c; r.r_cx=0; r.r_ds=FP_SEG(name); r.r_si=FP_OFF(name);
  r.r_bx=(mode=='r'?0:1);
  switch(mode) {
    case 'w':r.r_dx=0x0012; break;
    case 'a':r.r_dx=0x0011; break;
    default :r.r_dx=0x0001; break;
  }
  intr(0x21,&r);
  if(r.r_ax==0x7100) { r.r_ax=0x6c00; intr(0x21,&r); }
  if(r.r_flags & 1) return(-1);
  return(r.r_ax);
}

// conversion from PalmOS Date (seconds) na my DateTime
void ConvertDate (unsigned long datein, DateType *dateout) {
int days;
int dcnt[12]={31,28,31,30,31,30,31,31,30,31,30,31};
// cas
  dateout->sec=datein%60;
  datein/=60;
  dateout->min=datein%60;
  datein/=60;
  dateout->hour=datein%24;
  datein/=24;
// datum
  dateout->year=1904;
  days=366;
  while (datein>=days) {
    datein-=days;
    dateout->year++;
    days=(dateout->year%4)?365:366;
  }
  days=0;
  dcnt[1]=(dateout->year%4)?28:29;
  while (datein>=dcnt[days]) {
    datein-=dcnt[days];
    days++;
  }
  dateout->mon=days+1;
  dateout->day=datein+1;
}

// global variables
PDB_header hdr;
List_header lst;
List_record *ptrs;
RecordType Record;
DateType date;
int out_mode;

// loads PDB file and makes conversion to plaintext/TeX...
int LoadPDB (int handle) {
int records, i, fl;
char *s;
  ptrs=NULL;
  if (read (handle, &hdr, sizeof (PDB_header))<=0) return 1;
  SB (&hdr.cdate, 4);
  SB (&hdr.mdate, 4);
  SB (&hdr.lbdate, 4);
  SB (&hdr.modnum, 4);
  fprintf (stderr, Name ": %s\n", hdr.name);
  fprintf (stderr, CrDate ": %lu\n", hdr.cdate);
  fprintf (stderr, MoDate ": %lu\n", hdr.mdate);
  fprintf (stderr, BcDate ": %lu\n", hdr.lbdate);
  fprintf (stderr, ModNr ": %lu\n", hdr.modnum);
  fprintf (stderr, CrID ": %c%c%c%c, " DBtype ": %c%c%c%c\n",
    hdr.creator[0], hdr.creator[1], hdr.creator[2], hdr.creator[3],
    hdr.type[0], hdr.type[1], hdr.type[2], hdr.type[3]);
  if (read (handle, &lst, sizeof (List_header))<=0) return 2;
  SB (&lst.ID, 4);
  SB (&lst.number, 2);
  fprintf (stderr, ItemNr ": %u\n", lst.number);
  if (!lst.number) return 0;
  if ((ptrs=malloc (lst.number*sizeof (List_record)))==NULL) return 3;
  if ((records=read (handle, ptrs, sizeof (List_record)*lst.number)/sizeof (List_record))<=0) return 4;
  fprintf (stderr, ItemRd ": %u\n", records);
  if (out_mode==TeXinclude)
// TeX macros doesn't contain language specific texts, so this can be omitted
// \\input " TeXdef "\n
    fprintf (stdout, "\\input fotopad.tex\n%%%% " SmallHlp "\n"\
	"\\min=-1\n%%%% " NrOffs "\n\\offs=-2\n"\
	"%%%% " FrameShift "\n\\shift=0\n"\
	"%%%% " MaxNr "\n\\max=36\n"\
	"%%%% ""\n");
  for (i=0; i<records; i++) {
    SB (&ptrs[i].offs, 4);
    if (lseek (handle, ptrs[i].offs, SEEK_SET)<0L) return 5;
    if (read (handle, &Record, sizeof (RecordType))<(sizeof (RecordType)-4000)) return 6;
// prepare data for printing
    SB (&Record.DateTime, 4);
    SB (&Record.ohnisko, 2);
    SB (&Record.clona, 2);
    SB (&Record.cas, 2);
    SB (&Record.korekce, 2);
    ConvertDate (Record.DateTime, &date);
// print data according to selected mode
    switch (out_mode) {
      case PlainText:
	fprintf (stdout, "%i:\t%s\n", i, Record.popis);
	fprintf (stdout, "\t" Date ": ");
#ifdef DebugVersion
	fprintf (stdout, "%lu -- ", Record.DateTime);
#endif
	fprintf (stdout, "%hi.%hi.%u %hi:%02hi:%02hi\n", date.day, date.mon, date.year, date.hour, date.min, date.sec);
	fprintf (stdout, "\t" Lens ": %s, " Focal ": ", Record.objektiv);
	if (Record.ohnisko) fprintf (stdout, "%imm", Record.ohnisko);
	else fprintf (stdout, "--");
	fprintf (stdout, "\n\t" Aperture ": ");
	if (Record.clona) fprintf (stdout, "%i.%i", Record.clona/10, Record.clona%10);
	else fprintf (stdout, "--");
	fprintf (stdout, ", " Speed ": ");
	if (Record.cas) {
	  if (Record.cas<0) fprintf (stdout, "1/%i", -Record.cas);
	  else fprintf (stdout, "%i", Record.cas);
	} else fprintf (stdout, "--");
	fprintf (stdout, "\n\t" Correction ": ");
	if (Record.korekce) fprintf (stdout, "%i.%iEV", (Record.korekce-1000)/10, (Record.korekce<1000)?(1000-Record.korekce)%10:(Record.korekce-1000)%10);
	else fprintf (stdout, "--");
	fprintf (stdout, ", " Filter ": %s\n", Record.filtr);
	fprintf (stdout, "\t" Other ": "); fl=0;
	if (Record.flags&0x01) {fprintf (stdout, AE); fl=1;}
	if (Record.flags&0x02) {if (fl==1) fprintf (stdout, ", "); fprintf (stdout, AElock); fl=1;}
	if (Record.flags&0x04) {if (fl==1) fprintf (stdout, ", "); fprintf (stdout, Tripod); fl=1;}
	if (Record.flags&0x08) {if (fl==1) fprintf (stdout, ", "); fprintf (stdout, Flash); fl=1;}
	fprintf (stdout, "\n");
	break;
      case TeXinclude:
	fprintf (stdout, "\\frame{%i}{", i);
// searching for control characters and converting them appropriately to TeX macros
	s=&Record.popis;
	fl=0;
	while (*s) {
	  if (*s>=' ' || *s<'\0') {
	    if (fl) {fprintf (stdout, "\n\n"); fl=0;}
	    fputc (*s, stdout);
	  }
	  if (*s=='\n')
	    fl=1;
	  s++;
	}
	fprintf (stdout, "}%%\n");

	fprintf (stdout, "\\date{%hi.%hi.%u}{%hi:%02hi:%02hi}%%\n", date.day, date.mon, date.year, date.hour, date.min, date.sec);
	fprintf (stdout, "\\lens{%s}{", Record.objektiv);
	if (Record.ohnisko) fprintf (stdout, "%i", Record.ohnisko);
//	else fprintf (stdout, "-");
	fprintf (stdout, "}%%\n\\exposition{");
	if (Record.clona) fprintf (stdout, "%i.%i", Record.clona/10, Record.clona%10);
//	else fprintf (stdout, "-");
	fprintf (stdout, "}{");
	if (Record.cas) {
	  if (Record.cas<0) fprintf (stdout, "1/%i", -Record.cas);
	  else {
	    fprintf (stdout, "%i", Record.cas/10);
	    if (Record.cas%10) fprintf (stdout, ".%i", Record.cas%10);
	  }
	} //else fprintf (stdout, "-");
	fprintf (stdout, "}%%\n\\correction{");
	if (Record.korekce) fprintf (stdout, "%i.%i", (Record.korekce-1000)/10, (Record.korekce<1000)?(1000-Record.korekce)%10:(Record.korekce-1000)%10);
//	else fprintf (stdout, "-");
	fprintf (stdout, "}{%s}%%\n", Record.filtr);
	fprintf (stdout, "\\options{");
	if (Record.flags&0x01) fprintf (stdout, AE);
	fprintf (stdout, "}{");
	if (Record.flags&0x02) fprintf (stdout, AElock);
	fprintf (stdout, "}{");
	if (Record.flags&0x04) fprintf (stdout, Tripod);
	fprintf (stdout, "}{");
	if (Record.flags&0x08) fprintf (stdout, Flash);
	fprintf (stdout, "}%%\n");
	break;
    }
  }
  if (out_mode==TeXinclude)
    fprintf (stdout, "%%%% " EndOfData "\n\\bye\n");
  return 0;
}

void main (int argc, char *argv[]) {
int handle;
int i;

  fprintf (stderr, "This is PDB-to-Text File converter for FotoPad PDB files V0.95\n");
  if (argc<3) {
    fprintf (stderr, "Usage:\nFOTOPAD.EXE input-file.PDB output-mode\nOutput mode: 1-plain text, 2-TeX file\n");
    return;
  }
  sscanf (argv[2], "%i", &out_mode);
  if (out_mode<1 || out_mode>MaxMode) {
    fprintf (stderr, "Illegal output mode number!\n");
    return;
  }
//  if ((f=fopen (argv[1], "rb"))==NULL) {
  if ((handle=lfn_open (argv[1], 'r'))==-1) {
    fprintf (stderr, "Cannot open file %s!\n", argv[1]);
    return;
  }
  if (i=LoadPDB (handle)) fprintf (stderr, "Error %i!\n", i);
  else fprintf (stderr, "Done.\n");
  if (ptrs!=NULL) free (ptrs);
  close (handle);
  return;
}
